package questioncomplementaire;

import chiffrement.EncodeurAClef;

public class CodageAClef extends AlgoCodage {
	
	EncodeurAClef encodeur;
	String clef;
	
	public CodageAClef(String clef) {
		if(clef.equals(""))
			this.clef = "clef par défaut";
		else
			this.clef = clef;
		
		try {
			encodeur = new EncodeurAClef(this.clef);
		} catch (Exception e) {
			System.out.println("Échec de la création de l'encodeur");
			e.printStackTrace();
		}
	}
	
	@Override
	public String encode(String s) {
		return encodeur.chiffre(s);
	}

	@Override
	public String decode(String s) {
		return encodeur.dechiffre(s);
	}

	@Override
	public String toString() {
		return "codage à clef (clef = \"" + clef + "\")";
	}

}
