package questioncomplementaire;

/**
 * @author galtier
 * 
 *  Cette classe représente une feuille d'un arbre de Huffman.
 *
 */

public class Feuille extends Arbre {
	final char lettre;

	/**
	 * @param frequence nombre d'occurences de cette lettre dans le générateur
	 * @param lettre caractère dont on compte le nombre d'occurences
	 */
	public Feuille(int frequence, char lettre) {
		super(frequence);
		this.lettre = lettre;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Feuille other = (Feuille) obj;
		if ((lettre != other.lettre) || (this.frequence != other.frequence))
			return false;
		return true;
	}
	
	
}