package questioncomplementaire;

import java.io.BufferedReader;
import java.io.FileReader;

/**
 * @author galtier
 *
 */
public class Utilitaire {

	/**
	 * Lit un fichier texte et place les caractères lus dans une chaîne de
	 * caractères.
	 * 
	 * @param nomFichier
	 *            le nom complet du fichier à lire
	 * @return une chaine de caractères contenant le texte lu dans le fichier.
	 *         Si le fichier n'existe pas ou ne peut pas être lu, retourne null.
	 * 
	 */
	public static String lireTexte(String nomFichier) {
		try {
			String texte = "";
			FileReader fr = new FileReader(nomFichier);
			BufferedReader br = new BufferedReader(fr);
			String ligne;
			while ((ligne = br.readLine()) != null)
				texte += ligne + "\n";
			return texte;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
	
	/**
	 * Supprime tous les caractères qui ne sont pas des lettres
	 * et met les autres en majuscules.
	 * @param input La chaîne à traîter.
	 * @return La chaîne de caractères traîtée.
	 */
	public static String getLettres(String input) {
		return input.replaceAll("[^a-zA-Z]*", "").toUpperCase();
	}
}
